"test.MRO.snapshot.date" <- function()
{
      DEACTIVATED("This test is DEACTIVATED due to failure in 3.3.2")
          
      mro.expected.snapshot.date <- utils::packageDescription("RevoUtils")$MRANDate
      reposinfo <- options()$repos
      # Extract snapshot date from repository information.
      slashpos <- gregexpr("/", reposinfo, fixed = TRUE)[[1]]
      slashpos.len <- length(slashpos)
      lastslash.pos <- slashpos[slashpos.len]
      mro.verified.snapshot.date <- substring(reposinfo, lastslash.pos + 1, nchar(reposinfo))
      names(mro.verified.snapshot.date.URL) <- NULL
      checkEquals(mro.expected.snapshot.date, mro.verified.snapshot.date)
}

"test.MRO.MKL.installed" <- function()
{
      DEACTIVATED("This test is DEACTIVATED due to failure in 3.3.2")
      
      # Set correct MRO and R version string.
      MRO.Linux.base.path <- "/usr/lib64/MRO-"
      MRO.Windows.base.path <- "C:/Program Files/Microsoft/MRO/"
      MRO.version <- paste(R.version$major, ".", R.version$minor, sep ="") 
      Blas.Linux.basename <- "libRblas.so"
      Blas.Win.basename <- "RevoUtilsMath.dll"
           
      Rblas.Linux.path <- paste(MRO.Linux.base.path, MRO.version, "/", "R-", MRO.version, "/lib64/R/lib/", Blas.Linux.basename, sep = "")
      Rblas.Windows.path <- paste(MRO.Windows.base.path, "R-", MRO.version, "/library/RevoUtilsMath/libs/x64/", Blas.Win.basename, sep = "")	

      if(Sys.info()['sysname'] == "Linux")
      {        
	   # Get a lost of symbols contained in 'libRblas.so'.
           system(paste("nm", Rblas.Linux.path, ">", "mklinfo.txt", sep = " "))

           # Now search for the symbol 'i_free' in mklinfo - it should be there if MKL is installed and return "0".
           blas.test.expected.value <- "0"
           is.blas.installed <- system("grep -q 'i_free' mklinfo.txt && echo $?", intern=TRUE)          
           checkEquals(blas.test.expected.value, is.blas.installed)
       } 

       if(Sys.info()['sysname'] == "Windows")
       {
            # On Windows just check for existance of 'RevoUtilsMath.dll' on the build system,
            # since file is only there if MKL components are installed.
            blas.test.expected.value <- TRUE
            is.blas.installed <- file.exists(Rblas.Windows.path)
            checkEquals(blas.test.expected.value, is.blas.installed)
       } 
}	

"test.MRO.default.packages.install" <- function()
{
    DEACTIVATED("This test is DEACTIVATED due to failure in 3.3.2")
    
    # Set 'RHOME' and library path for each MRO platform.
    MRO.Linux.base.path <- "/usr/lib64/MRO-"
    MRO.Windows.base.path <- "C:/Program Files/Microsoft/MRO/"
    MRO.Mac.base.path <- "/Library/Frameworks/R.framework/Versions/3.3-MRO/Resources"
    MRO.version <- paste(R.version$major, ".", R.version$minor, sep = "")
    MRO.Linux.libpath <- .libPaths()[1]
    MRO.Windows.libpath <- .libPaths()[1]
    MRO.Mac.libpath <- .libPaths()[1]
    sysname <- Sys.info()['sysname']
    sysname <- sysname[[1]]


    if (sysname == "Linux")
    {
        MRO.R.BaseObjects.Dir <- file.path(MRO.Linux.libpath, "RevoIOQ/unitTestData/capvecdata")
        load(file.path(MRO.R.BaseObjects.Dir, "MRO.Linux.pack.sav"))
        expected.package.list <- curinstall.packages
        initial.package.list <- row.names(installed.packages())
        pack.all.exist <- all(expected.package.list %in% initial.package.list)
        missing.packages <- unique(expected.package.list[expected.package.list %in% initial.package.list == FALSE])
    }

    if (sysname == "Windows")
    {
        MRO.R.BaseObjects.Dir <- file.path(MRO.Windows.libpath, "RevoIOQ/unitTestData/capvecdata")
        load(file.path(MRO.R.BaseObjects.Dir, "MRO.Windows.pack.sav"))
        expected.package.list <- curinstall.packages
        initial.package.list <- row.names(installed.packages())
        pack.all.exist <- all(expected.package.list %in% initial.package.list)
        missing.packages <- unique(expected.package.list[expected.package.list %in% initial.package.list == FALSE])
    } 

    if (sysname == "Darwin")
    {
        MRO.R.BaseObjects.Dir <- file.path(MRO.Mac.libpath, "RevoIOQ/unitTestData/capvecdata")
        load(file.path(MRO.R.BaseObjects.Dir, "MRO.Mac.pack.sav"))
        expected.package.list <- curinstall.packages
        initial.package.list <- row.names(installed.packages())
        pack.all.exist <- all(expected.package.list %in% initial.package.list)
        missing.packages <- unique(expected.package.list[expected.package.list %in% initial.package.list == FALSE])
    }
    
    if (pack.all.exist == FALSE)
    {
        for (i in 1:length(missing.packages))
            print(paste("Test failed - package:", missing.packages[i], "is missing.", sep = " "))
        
    }

    checkEquals(expected.package.list, initial.package.list)
}
	
"test.MRO.capabilities" <- function()
{
    DEACTIVATED("This test is DEACTIVATED due to failure in 3.3.2")
    
    MRO.Linux.libpath <- .libPaths()[1]
    MRO.Windows.libpath <- .libPaths()[1]
    MRO.Mac.libpath <- .libPaths()[1]
    sysname <- Sys.info()['sysname']
    sysname <- sysname[[1]]
    
    if(sysname == "Linux")
    {
        MRO.R.BaseObjects.Dir <- file.path(MRO.Linux.libpath, "RevoIOQ/unitTestData/capvecdata")
			  
	    if(file.exists("/etc/redhat-release") == TRUE) {
            load(file.path(MRO.R.BaseObjects.Dir, "capvec-CentOS7.sav"))
        } else if (file.exists("/etc/lsb-release") == TRUE)
        {    
            load(file.path(MRO.R.BaseObjects.Dir, "capvec-MRO-UB1504.sav"))
        } else if (file.exists("/etc/SuSE-release") == TRUE)
        {
            load(file.path(MRO.R.BaseObjects.Dir, "capvec-SLES11.sav"))
        }
        curbuild.capabilities.list <- capabilities()
    }
        
    if(sysname == "Windows")
    {
       	MRO.R.BaseObjects.Dir <- file.path(MRO.Windows.libpath, "RevoIOQ/unitTestData/capvecdata")
		load(file.path(MRO.R.BaseObjects.Dir, "capvec-MRO-Win10.sav"))
    }

    if (sysname == "Darwin")
    {
        MRO.R.BaseObjects.Dir <- file.path(MRO.Mac.libpath, "RevoIOQ/unitTestData/capvecdata")
        load(file.path(MRO.R.BaseObjects.Dir, "capvec-MRO-Mac.sav"))   
    }

    curbuild.capabilities.list <- capabilities()   

    # After loading base object, this will create vector 'cap.vec'.
	checkEquals(cap.vec, curbuild.capabilities.list)
}       	